tclap: TCLAP::CmdLineInterface Class Reference

# TCLAP::CmdLineInterface Class Reference

The base class that manages the command line definition and passes along the parsing to the appropriate Arg classes. More...

`#include <CmdLineInterface.h>`

Inheritance diagram for TCLAP::CmdLineInterface:

List of all members.

## Public Member Functions
virtual | ~CmdLineInterface ()
| Destructor.
virtual void | add (Arg &a)=0
| Adds an argument to the list of arguments to be parsed.
virtual void | add (Arg *a)=0
| An alternative add.
virtual void | xorAdd (Arg &a, Arg &b)=0
| Add two Args that will be xor'd.
virtual void | xorAdd (std::vector< Arg * > &xors)=0
| Add a list of Args that will be xor'd.
virtual void | parse (int argc, const char *const *argv)=0
| Parses the command line.
void | parse (std::vector< std::string > &args)
| Parses the command line.
virtual CmdLineOutput * | getOutput ()=0
| Returns the CmdLineOutput object.
virtual void | setOutput (CmdLineOutput *co)=0
virtual std::string & | getVersion ()=0
| Returns the version string.
virtual std::string & | getProgramName ()=0
| Returns the program name string.
virtual std::list< Arg * > & | getArgList ()=0
| Returns the argList.
virtual XorHandler & | getXorHandler ()=0
| Returns the XorHandler.
virtual char | getDelimiter ()=0
| Returns the delimiter string.
virtual std::string & | getMessage ()=0
| Returns the message string.
virtual bool | hasHelpAndVersion ()=0
| Indicates whether or not the help and version switches were created automatically.
virtual void | reset ()=0
| Resets the instance as if it had just been constructed so that the instance can be reused.

## Detailed Description

The base class that manages the command line definition and passes along the parsing to the appropriate Arg classes.

Definition at line 43 of file CmdLineInterface.h.

## Constructor & Destructor Documentation

virtual TCLAP::CmdLineInterface::~CmdLineInterface | ( |  | ) | `[inline, virtual]`

Destructor.

Definition at line 50 of file CmdLineInterface.h.

## Member Function Documentation

virtual void TCLAP::CmdLineInterface::add | ( | Arg * | a | ) | `[pure virtual]`

An alternative add.

Functionally identical.

Parameters:

  | a | - Argument to be added.

Implemented in TCLAP::CmdLine.

virtual void TCLAP::CmdLineInterface::add | ( | Arg & | a | ) | `[pure virtual]`

Adds an argument to the list of arguments to be parsed.

Parameters:

  | a | - Argument to be added.

Implemented in TCLAP::CmdLine.

Referenced by TCLAP::MultiArg< T >::MultiArg(), TCLAP::MultiSwitchArg::MultiSwitchArg(), TCLAP::SwitchArg::SwitchArg(), TCLAP::UnlabeledMultiArg< T >::UnlabeledMultiArg(), TCLAP::UnlabeledValueArg< T >::UnlabeledValueArg(), and TCLAP::ValueArg< T >::ValueArg().

virtual std::list<Arg*>& TCLAP::CmdLineInterface::getArgList | ( |  | ) | `[pure virtual]`

Returns the argList.

Implemented in TCLAP::CmdLine.

Referenced by TCLAP::StdOutput::_longUsage(), TCLAP::StdOutput::_shortUsage(), TCLAP::ZshCompletionOutput::usage(), and TCLAP::DocBookOutput::usage().

virtual char TCLAP::CmdLineInterface::getDelimiter | ( |  | ) | `[pure virtual]`

Returns the delimiter string.

Implemented in TCLAP::CmdLine.

Referenced by TCLAP::ZshCompletionOutput::usage(), and TCLAP::DocBookOutput::usage().

virtual std::string& TCLAP::CmdLineInterface::getMessage | ( |  | ) | `[pure virtual]`

Returns the message string.

Implemented in TCLAP::CmdLine.

Referenced by TCLAP::StdOutput::_longUsage(), and TCLAP::DocBookOutput::usage().

virtual CmdLineOutput* TCLAP::CmdLineInterface::getOutput | ( |  | ) | `[pure virtual]`

Returns the CmdLineOutput object.

Implemented in TCLAP::CmdLine.

virtual std::string& TCLAP::CmdLineInterface::getProgramName | ( |  | ) | `[pure virtual]`

Returns the program name string.

Implemented in TCLAP::CmdLine.

Referenced by TCLAP::StdOutput::_shortUsage(), TCLAP::StdOutput::failure(), TCLAP::ZshCompletionOutput::usage(), TCLAP::DocBookOutput::usage(), and TCLAP::StdOutput::version().

virtual std::string& TCLAP::CmdLineInterface::getVersion | ( |  | ) | `[pure virtual]`

Returns the version string.

Implemented in TCLAP::CmdLine.

Referenced by TCLAP::ZshCompletionOutput::usage(), TCLAP::DocBookOutput::usage(), TCLAP::ZshCompletionOutput::version(), TCLAP::StdOutput::version(), and TCLAP::DocBookOutput::version().

virtual XorHandler& TCLAP::CmdLineInterface::getXorHandler | ( |  | ) | `[pure virtual]`

Returns the XorHandler.

Implemented in TCLAP::CmdLine.

Referenced by TCLAP::StdOutput::_longUsage(), TCLAP::StdOutput::_shortUsage(), TCLAP::ZshCompletionOutput::getMutexList(), and TCLAP::DocBookOutput::usage().

virtual bool TCLAP::CmdLineInterface::hasHelpAndVersion | ( |  | ) | `[pure virtual]`

Indicates whether or not the help and version switches were created automatically.

Implemented in TCLAP::CmdLine.

Referenced by TCLAP::StdOutput::failure().

void TCLAP::CmdLineInterface::parse | ( | std::vector< std::string > & | args | ) |

Parses the command line.

Parameters:

  | args | - A vector of strings representing the args. args[0] is still the program name.

Reimplemented in TCLAP::CmdLine.

virtual void TCLAP::CmdLineInterface::parse | ( | int | argc,
|  | const char *const * | argv |
| ) |  |  | `[pure virtual]`

Parses the command line.

Parameters:

  | argc | - Number of arguments.
  | argv | - Array of arguments.

Implemented in TCLAP::CmdLine.

virtual void TCLAP::CmdLineInterface::reset | ( |  | ) | `[pure virtual]`

Resets the instance as if it had just been constructed so that the instance can be reused.

Implemented in TCLAP::CmdLine.

virtual void TCLAP::CmdLineInterface::setOutput | ( | CmdLineOutput * | co | ) | `[pure virtual]`

Parameters:

  | co | - CmdLineOutput object that we want to use instead.

Implemented in TCLAP::CmdLine.

virtual void TCLAP::CmdLineInterface::xorAdd | ( | std::vector< Arg * > & | xors | ) | `[pure virtual]`

Add a list of Args that will be xor'd.

If this method is used, add does not need to be called.

Parameters:

  | xors | - List of Args to be added and xor'd.

Implemented in TCLAP::CmdLine.

virtual void TCLAP::CmdLineInterface::xorAdd | ( | Arg & | a,
|  | Arg & | b |
| ) |  |  | `[pure virtual]`

Add two Args that will be xor'd.

If this method is used, add does not need to be called.

Parameters:

  | a | - Argument to be added and xor'd.
  | b | - Argument to be added and xor'd.

Implemented in TCLAP::CmdLine.

The documentation for this class was generated from the following file:

- CmdLineInterface.h